'use strict';

var _utils = require('./utils');

var _graph = require('./graph');

var _graph2 = _interopRequireDefault(_graph);

var _errors = require('./errors');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Graphology Reference Implementation Endoint
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * ============================================
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Importing the Graph object & deriving alternative constructors.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */


/**
 * Alternative constructors.
 */
var DirectedGraph = function (_Graph) {
  _inherits(DirectedGraph, _Graph);

  function DirectedGraph(data, options) {
    _classCallCheck(this, DirectedGraph);

    return _possibleConstructorReturn(this, _Graph.call(this, data, (0, _utils.assign)({ type: 'directed' }, options)));
  }

  return DirectedGraph;
}(_graph2.default);

var UndirectedGraph = function (_Graph2) {
  _inherits(UndirectedGraph, _Graph2);

  function UndirectedGraph(data, options) {
    _classCallCheck(this, UndirectedGraph);

    return _possibleConstructorReturn(this, _Graph2.call(this, data, (0, _utils.assign)({ type: 'undirected' }, options)));
  }

  return UndirectedGraph;
}(_graph2.default);

var MultiDirectedGraph = function (_Graph3) {
  _inherits(MultiDirectedGraph, _Graph3);

  function MultiDirectedGraph(data, options) {
    _classCallCheck(this, MultiDirectedGraph);

    return _possibleConstructorReturn(this, _Graph3.call(this, data, (0, _utils.assign)({ multi: true, type: 'directed' }, options)));
  }

  return MultiDirectedGraph;
}(_graph2.default);

var MultiUndirectedGraph = function (_Graph4) {
  _inherits(MultiUndirectedGraph, _Graph4);

  function MultiUndirectedGraph(data, options) {
    _classCallCheck(this, MultiUndirectedGraph);

    return _possibleConstructorReturn(this, _Graph4.call(this, data, (0, _utils.assign)({ multi: true, type: 'undirected' }, options)));
  }

  return MultiUndirectedGraph;
}(_graph2.default);

var GraphMap = function (_Graph5) {
  _inherits(GraphMap, _Graph5);

  function GraphMap(data, options) {
    _classCallCheck(this, GraphMap);

    return _possibleConstructorReturn(this, _Graph5.call(this, data, (0, _utils.assign)({ map: true }, options)));
  }

  return GraphMap;
}(_graph2.default);

var DirectedGraphMap = function (_Graph6) {
  _inherits(DirectedGraphMap, _Graph6);

  function DirectedGraphMap(data, options) {
    _classCallCheck(this, DirectedGraphMap);

    return _possibleConstructorReturn(this, _Graph6.call(this, data, (0, _utils.assign)({ map: true, type: 'directed' }, options)));
  }

  return DirectedGraphMap;
}(_graph2.default);

var UndirectedGraphMap = function (_Graph7) {
  _inherits(UndirectedGraphMap, _Graph7);

  function UndirectedGraphMap(data, options) {
    _classCallCheck(this, UndirectedGraphMap);

    return _possibleConstructorReturn(this, _Graph7.call(this, data, (0, _utils.assign)({ map: true, type: 'undirected' }, options)));
  }

  return UndirectedGraphMap;
}(_graph2.default);

var MultiDirectedGraphMap = function (_Graph8) {
  _inherits(MultiDirectedGraphMap, _Graph8);

  function MultiDirectedGraphMap(data, options) {
    _classCallCheck(this, MultiDirectedGraphMap);

    return _possibleConstructorReturn(this, _Graph8.call(this, data, (0, _utils.assign)({ map: true, multi: true, type: 'directed' }, options)));
  }

  return MultiDirectedGraphMap;
}(_graph2.default);

var MultiUndirectedGraphMap = function (_Graph9) {
  _inherits(MultiUndirectedGraphMap, _Graph9);

  function MultiUndirectedGraphMap(data, options) {
    _classCallCheck(this, MultiUndirectedGraphMap);

    return _possibleConstructorReturn(this, _Graph9.call(this, data, (0, _utils.assign)({ map: true, multi: true, type: 'undirected' }, options)));
  }

  return MultiUndirectedGraphMap;
}(_graph2.default);

/**
 * Exporting as CommonJS for convenience.
 */


_graph2.default.DirectedGraph = DirectedGraph;
_graph2.default.UndirectedGraph = UndirectedGraph;
_graph2.default.MultiDirectedGraph = MultiDirectedGraph;
_graph2.default.MultiUndirectedGraph = MultiUndirectedGraph;
_graph2.default.GraphMap = GraphMap;
_graph2.default.DirectedGraphMap = DirectedGraphMap;
_graph2.default.UndirectedGraphMap = UndirectedGraphMap;
_graph2.default.MultiDirectedGraphMap = MultiDirectedGraphMap;
_graph2.default.MultiUndirectedGraphMap = MultiUndirectedGraphMap;

_graph2.default.InvalidArgumentsGraphError = _errors.InvalidArgumentsGraphError;
_graph2.default.NotFoundGraphError = _errors.NotFoundGraphError;
_graph2.default.UsageGraphError = _errors.UsageGraphError;

module.exports = _graph2.default;